from bitcoding import B_dict
from basesplit import bsplit as split
from inverse import inv
from buildFromScen import buildFromScen
from solve import solve
from extractConScen import extractConScen
#import random
from repair import repair
from vbweights import w
from bitcoding import B_dict
from closedness import closedness
from checkFrozenTriples import checkFrozenTriples
from array import array
from counters import counter

DALL = B_dict['DALL']

cardmult = max(w)

def findParaScen(ConMatrix, neighbors, pc_only):

   frozen = set()
   frozenTriples = set()

   Vars = len(ConMatrix)
   
   repair(tuple([c[:] for c in ConMatrix]), neighbors, pc_only, frozen)
   
   # Comment above line (repair...) and uncomment below lines of code to get the worst initial starting point
   #frozen = set()
   #for i in range(Vars):
   #   for j in range(i+1, Vars):
   #      if ConMatrix[i][j] != DALL: frozen.add((i,j))
   
   # Comment above line (repair...) and uncomment below lines of code to get arbitrary starting point
   #frozen = set()
   #DALLmatrix = tuple([c[:] for c in ConMatrix])
   #for i in range(Vars):
   #   for j in range(i+1, Vars):
   #      DALLmatrix[i][j] = DALL  
   #      DALLmatrix[j][i] = DALL  
   #scenario_0 = extractConScen(DALLmatrix, neighbors, set())
   #for i in range(Vars):
   #   for j in range(i+1, Vars):
   #      if not scenario_0[i][j] & ConMatrix[i][j]: frozen.add((i,j))
   
   P = tuple([c[:] for c in ConMatrix])
   
   for (i,j) in frozen:
      P[i][j] = DALL
      P[j][i] = DALL      
   
   lfrozen = list(frozen)
   for (i,j) in lfrozen:
      
      Pc = tuple([c[:] for c in P])   
      Pc[i][j] = ConMatrix[i][j]      
      Pc[j][i] = ConMatrix[j][i]      
      
      solution, _ = solve(Pc, neighbors, pc_only, frozen - set([(i,j)]))
      counter['oracle'] += 1
         
      if solution:
         frozen.remove((i,j))
         P[i][j] = ConMatrix[i][j]
         P[j][i] = ConMatrix[j][i]            
      
   parascenario = P

   for (i,j) in frozen:
      for k in range(Vars):
         if tuple(sorted((i,k))) in frozen and tuple(sorted((k, j))) in frozen:
            frozenTriples.add(tuple(sorted((i,j,k))))

   for (i,j) in frozen:
      M = set()
      for b in split[DALL-1][1][:]:
         M.add((i,b,j))
      
      while M and split[P[i][j]-1][0] > 2 :
         for i,b,j in M: 
            
            if (ConMatrix[i][j] & (P[i][j]^b)):
               break
         else:
            break
            
         r = P[i][j] ^ b  
         if r <= 0: raise RuntimeError("Can't happen")
   
         Pc = tuple([c[:] for c in P])   
         Pc[i][j] = r    
         Pc[j][i] = inv[r-1]   
         
         if checkFrozenTriples(Pc, frozenTriples):
            solution, _ = solve(Pc, neighbors, pc_only, frozen)
            counter['oracle'] += 1

            if solution:
               P[i][j] = r    
               P[j][i] = inv[r-1]
               parascenario = P 
            
         M.remove((i,b,j))
   
   parascenario = extractConScen(solve(tuple([c[:] for c in parascenario]), neighbors, pc_only, frozen)[0], neighbors, frozen)
   counter['oracle'] += 1
   
   if not(closedness(parascenario, neighbors, frozen)): raise RuntimeError("Can't happen")
   
   return parascenario
