from glob import globs
from solve import solve
from inverse import inv
from bitcoding import B_dict
from counters import counter

DALL = B_dict['DALL']

if globs['pcheuristic'] == 0: # path consistency
   from spc import sPC as pc 
elif globs['pcheuristic'] == 1: # path consistency with weighted queue
   from spcw import sPCw as pc
   
def repair(ConMatrix, neighbors, pc_only, frozen):

   fixes = []
   visited = set()
   
   solution, fail = solve(tuple([c[:] for c in ConMatrix]), neighbors, pc_only, set())
   counter['oracle'] += 1
   
   if solution: return solution, ()
   
   i,j = fail
   fixes.append((i,j))
   visited.add((i,j))

   while 1:
   
      neighbors = []
      
      if len(fixes) > len(set(fixes)): raise Exception("duplicates")

      while fixes:
         (i,j) = fixes.pop()
         
         neighbors.append((i,j))

         ConMatrix[i][j] = DALL
         ConMatrix[j][i] = DALL 
         
         frozen.add((i,j))      

         solution, fail = solve(tuple([c[:] for c in ConMatrix]), neighbors, pc_only, set())
         counter['oracle'] += 1
         
         if solution: 
            return solution, ()
            
         m, n = fail   
         if (m,n) not in visited:
            fixes.append((m,n))
            visited.add((m,n))
      else:
         for (i,j) in neighbors:
            for k in range(len(ConMatrix)):
               if ConMatrix[k][j] != DALL and i != k != j and tuple(sorted((k,j))) not in visited:
                  fixes.append((k,j) if k < j else (j,k))
                  visited.add((k,j) if k < j else (j,k))
               if ConMatrix[i][k] != DALL and i != k != j and tuple(sorted((i,k))) not in visited:
                  fixes.append((i,k) if i < k else (k,i))
                  visited.add((i,k) if i < k else (k,i))
                  
         if not fixes: raise RuntimeError("Can't happen")
